#include <ntf.h>
#include "node.h"

static Plist *pathlist;
static char *realpath;

ulong
searchpath(char *name)
{
	static ulong path = 0;
	Plist *p;
	for(p = pathlist; p!=nil; p=p->next){
		if(strcmp(p->name, name) == 0){
			return p->path;
		}
	}

	p = emalloc(sizeof(Plist));
	p->name = estrdup(name);
	p->path = ++path;
	p->next = pathlist;
	pathlist = p;
	return p->path;

}



Node*
newnode(Node *parent, char *name)
{
	Node *np;
	char *pathname;
	Dir *d;

	np = emalloc(sizeof(Node));
	np->fd = -1;
	np->open = 0;


	if(parent != nil){
		np->parent = parent;

		/* unless end with slash */
		if(*(parent->realname+strlen(parent->realname)-1)!='/'){
			pathname = (char*)emalloc(strlen(parent->realname)+strlen(name)+2);
			sprint(pathname,"%s/%s",parent->realname,name);
		}else{
			pathname = (char*)emalloc(strlen(parent->realname)+strlen(name)+1);
			sprint(pathname,"%s%s",parent->realname,name);
		}

	}else{
		np->parent = np;
		pathname = (char*)emalloc(strlen(realpath)+strlen(name)+1);
		sprint(pathname, "%s%s",realpath, name);
	}

	d = dirstat(pathname);
	d->qid.path = searchpath(pathname);
	np->d = reallocdir(d, 0);
	np->realname = estrdup(pathname);

	return np;
}


void
setpath(char *path)
{
	realpath = path;
}

Dir*
reallocdir(Dir *d, int dofree)
{
	Dir *dp;
	char *p;
	int nn, ng, nu, nm;

	if(d->name == nil)
		d->name = "?name?";
	if(d->uid == nil)
		d->uid = "?uid?";
	if(d->gid == nil)
		d->gid = d->uid;
	if(d->muid == nil)
		d->muid = d->uid;
	nn = strlen(d->name)+1;
	nu = strlen(d->uid)+1;
	ng = strlen(d->gid)+1;
	nm = strlen(d->muid)+1;
	dp = emalloc(sizeof(Dir)+nn+nu+ng+nm);
	*dp = *d;

	p = dp->name;
	strncpy(p, d->name, nn);
	p = dp->uid;
	strncpy(p, d->uid, nu);
	p = dp->gid;
	strncpy(p, d->gid, ng);
	p = dp->muid;
	strncpy(p, d->muid, nm);
	if(dofree)
		free(d);
	return dp;
}
