#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>


#pragma src "/sys/src/libstackfs"
#pragma lib "libstackfs.a"

#define emalloc emalloc9p
#define estrdup estrdup9p



typedef struct Stackfs Stackfs;
typedef struct Node Node;

struct Stackfs {
	void (*attach)(Req *r);
	char* (*walk1)(Fid *fid, char *name, Qid *qid);
	char* (*clone)(Fid *ofid, Fid *fid);	
	void (*read)(Req *r);
	void (*write)(Req *r);
	void (*stat)(Req *);
	void (*wstat)(Req *r);
	void (*open)(Req *r);
	void (*destroyfid)(Fid *fid);
	void (*create)(Req *r);
	
	void (*readfilter)(char *buf);
	void (*writefilter)(char *buf);

	char *realpath;
	
};

struct Node
{
	char	*realname;
	Dir	*d;
	Node	*parent;
	// Node	*children;
	// Node	*sibs;
	// char *childname;
	int		fd;
	int		open;
	Qid	qid;
};





void poststackfs(Stackfs *srv, char *srvname, char *mtpt, int flag);
